package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10056RuKuNewWineResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10056SendBeanNewWine;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10056RuKuNewWine extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10056 = 10056;

	private Gson gson;

	private Prot10056RuKuNewWineResult res;

	public Prot10056RuKuNewWineResult getRes() {
		return res;
	}

	public void setRes(Prot10056RuKuNewWineResult res) {
		this.res = res;
	}

	public Prot10056RuKuNewWine() {
		gson = new Gson();
	}

	public void dealRuKuNewWine(SocketCreate create,
                                Prot10056SendBeanNewWine rukuBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), rukuBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10056SendBeanNewWine rukuBean)
			throws IOException {
		if (socket.isConnected()) {

			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10056, "开始发送登录信息");
				sendProt(dos, rukuBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10056, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10056, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10056RuKuNewWineResult.class);
		}
		recCheckCode(dis);
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos,
			Prot10056SendBeanNewWine rukuBean) throws IOException {
		String bodyContent = gson.toJson(rukuBean).toString();
		System.out.println("---json"+bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10056, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}
}
